<?php

namespace HCM\AVL\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Avaliacao\Entities\Resposta;
use Teknisa\Model\Avaliacao\Entities\Questpadraval;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
      //Reuniao
class QuestModeloService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, \HCM\AVL\Repository\QuestModeloRepository $questModeloRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->questModeloRepository = $questModeloRepository;
        $this->resposta = Repositories::RESPOSTA;
        $this->questao = Repositories::QUESTAO;
        $this->combinacao = Repositories::COMBQUESTPADR;
    }
    
    public function cadastroAutomatico($nrquestao_list,$dsResposta,$vrPesoResposta,$nrOrdenaRespost,$cdIntegracao,$idResposCorreta,$idAtivo,$nrorg,$nrorgpadrao,$dtmescompetenc){
        try{
            foreach($nrquestao_list as $nrquestao){
                if($this->respExists($this->hcmParameters->getNrorgTrabalho(),$nrquestao,$dsResposta)){
                    $object = $this->questModeloRepository->getResposta($this->hcmParameters->getNrorgTrabalho(),$nrquestao,$dsResposta);
                    foreach($object as $obj){
                        $obj->setDtultatu(DateUtil::getDataAtual());
                        $obj->setCdoperultatu($this->hcmParameters->getCdoperador());
                        $obj->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
                        $obj->setCdintegracao($cdIntegracao);
                        $obj->setDsresposta($dsResposta);
                        $obj->setIdativo($idAtivo);
                        $obj->setIdresposcorreta($idResposCorreta);
                        $obj->setNrordenarespost($nrOrdenaRespost);
                        $obj->setVrpesoresposta($vrPesoResposta);
                        $this->entityManager->persist($obj);
                        $this->entityManager->flush();
                    
                    }
                }else{
                $codigo = \HCM\Util\NovoCodigo::geraCodigo($nrorg, 'RESPOSTA', 1, 12, true, false);
                $obj = new $this->resposta;
                $obj->setNrorg($this->hcmParameters->getNrorgTrabalho());
                $obj->setNrresposta($codigo);
                $obj->setNrquestao($nrquestao);
                $obj->setDtinclusao(DateUtil::getDataAtual());
                $obj->setCdoperinclusao($this->hcmParameters->getCdoperador());
                $obj->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
                $obj->setDtultatu(DateUtil::getDataAtual());
                $obj->setCdoperultatu($this->hcmParameters->getCdoperador());
                $obj->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
                $obj->setCdintegracao($cdIntegracao);
                $obj->setDsresposta($dsResposta);
                $obj->setIdativo($idAtivo);
                $obj->setIdresposcorreta($idResposCorreta);
                $obj->setNrordenarespost($nrOrdenaRespost);
                $obj->setVrpesoresposta($vrPesoResposta);
                $this->entityManager->persist($obj);
                $this->entityManager->flush();
                
                    
                }
            }
        }catch(\Exception $e){
            throw $e;
            
        }
    }
    
    public function novaQuestao($nrnivelpadquest,$txquestao,$idtipoquestao,$dtrevisaquestao,$idquestaoobriga,$idopcaoresposta,$idativo){
        try{
                $codigo = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'QUESTAO', 1, 22, true);
                $obj = new $this->questao;
                $obj->setNrorg($this->hcmParameters->getNrorgTrabalho());
                $obj->setNrquestao($codigo);
                $obj->setNrnivelpadquest($nrnivelpadquest);
                $obj->setTxquestao($txquestao);
                $obj->setIdtipoquestao($idtipoquestao);
                
                $obj->setIdquestaoobriga($idquestaoobriga);
                $obj->setIdopcaoresposta($idopcaoresposta);
                $obj->setIdativo($idativo);
                
                $data = DateUtil::getDataDeString($dtrevisaquestao);
                
                $obj->setDtrevisaquestao($data);
                
                $obj->setDtinclusao(DateUtil::getDataAtual());
                $obj->setCdoperinclusao($this->hcmParameters->getCdoperador());
                $obj->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
                $obj->setDtultatu(DateUtil::getDataAtual());
                $obj->setCdoperultatu($this->hcmParameters->getCdoperador());
                $obj->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
                
                $this->entityManager->persist($obj);
                $this->entityManager->flush();
                $ret = array($codigo,$txquestao);
                return $ret;
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function checaCombPad($nrorg){
        try{
            if($this->questModeloRepository->combPadraoExists($nrorg)){
                $codigo = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'COMBQUESTPADR', 1, 22, true);
                $obj = new $this->combinacao;
                $obj->setNrorg($this->hcmParameters->getNrorgTrabalho());
                $obj->setNrpadravaliacao(NULL);
                $obj->setNrcombquestpadr(1);
                $obj->setNmcombquestpadr('PADRÃO');
                $obj->setIdativo('S');
                $obj->setDtinclusao(DateUtil::getDataAtual());
                $obj->setCdoperinclusao($this->hcmParameters->getCdoperador());
                $obj->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
                $obj->setDtultatu(DateUtil::getDataAtual());
                $obj->setCdoperultatu($this->hcmParameters->getCdoperador());
                $obj->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
                
                $this->entityManager->persist($obj);
                $this->entityManager->flush($obj);
                $this->entityManager->commit();
                }
        }catch(\Exception $e){
            throw $e;
        }
    }
    
    public function validaSetQuestao($nrorg,$nrpadravaliacao,$nrquestao){
         $questoes = $this->entityManager->getRepository(Repositories::QUESTPADRAVAL)->findBy(
                array("nrorg"=>$nrorg,"nrpadravaliacao"=>$nrpadravaliacao,"nrquestao"=>$nrquestao)
            );
        return empty($questoes);
    }

    
    public function getNrQuestoes($comb,$agrup,$nivel,$tema,$ordem,$nrorg,$padraval){
            return $this->questModeloRepository->getQuestoes($comb,$agrup,$nivel,$tema,$ordem,$nrorg,$padraval);
    }
    
    public function getQuestaoSorteio($nrorg,$nivel,$idSorteio,$nrpadravaliacao){
            return $this->questModeloRepository->getQuestaoSorteio($nrorg,$nivel,$idSorteio,$nrpadravaliacao);
    }
    
    public function getDsQuestao($nrorg,$nrquestao){
            return $this->questModeloRepository->getDsQuestao($nrorg,$nrquestao);
    }
    
    public function questaoExists($nrorg,$padraval){
        return $this->questModeloRepository->questaoExists($nrorg,$padraval);
    }
    
    public function agrupExists($nrorg,$padraval){
        return $this->questModeloRepository->agrupExists($nrorg,$padraval);
    }
    
    public function combExists($nrorg,$padraval){
        return $this->questModeloRepository->combExists($nrorg,$padraval);
    }
    
    public function relacIsValid($nrorg,$padraval,$nrtiporelaciona,$isnew,$codigo){
        return $this->questModeloRepository->relacIsValid($nrorg,$padraval,$nrtiporelaciona,$isnew,$codigo);
    }
    
    public function relacExists($nrorg,$padraval){
        return $this->questModeloRepository->relacExists($nrorg,$padraval);
    }
    
    public function respExists($nrorg,$nrquestao,$dsResposta){
        return $this->questModeloRepository->respExists($nrorg,$nrquestao,$dsResposta);
    }
    
}