<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;

class FpaRegramEntity extends TkEntity
{
    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_dtmescompetenc;

    public function __construct($entityManager, $hcmParameters) {
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrgPadrao = $hcmParameters->getNrorgPadrao();
        $this->_nrOrg = $hcmParameters->getNrorgTrabalho();
        $this->_dtmescompetenc = $hcmParameters->getDtCompetencia();
        
        parent::__construct(null,$entityManager);
    }

    private function _inicializaLista(){
        $regras = $this->entityManager->getRepository(Repositories::FPA_REGRAM)->retornaRegras($this->_nrOrg, $this->_nrOrgPadrao, $this->_dtmescompetenc);
        foreach ($regras as $regra) {
            $this->addItem($regra);
        }
    }

    public function retornaRegras(){
        $this->_inicializaLista();
        $regras = $this->getItems();
        return $regras;
    }

    public function retornaRegra($nrRegra){
        $itens = $this->getItems();
        if (empty($itens) === true) {
            $this->_inicializaLista();
            $itens = $this->getItems();
        }
        foreach ($itens as $key=> $item) {
            if ((int)$item->getNrregram() === (int)$nrRegra) {
                return $itens[$key];
            }
        }
        return false;
    }

}