<?php

namespace HCM\FPA\Entity;

use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\Util\TkEntity;

class FpadirfmagnetEntity extends TkEntity
{
    private $objDirfMagnet;
    private $nrCpfAnterior;    
    private $idPrimeiraExec;    
    private $nrdirfmagnet;
    private $nrorg;
    private $mescompetencia;
    private $idtpinscestrutu;
    private $cdinscestrut;
    private $dtadmissaovinc;
    private $idtiporegistro;
    private $idrec;
    private $bpfdec;
    private $dslinharegistro;
    private $nrvinculom;
    private $nrpessoarespons;
    private $idativo;
    private $dtinclusao;
    private $dtultatu;
    private $nrorginclusao;
    private $cdoperinclusao;
    private $nrorgultatu;
    private $cdoperultatu;
    private $nrprocesso;
    private $dsnaturezarend;
    private $vrtotalrend;
    private $vrtotalprev;
    private $vrtotalprevcomp;
    private $vrtotalpensao;
    private $vrtotimpretido;
    private $vrparcelaisenta;
    private $vrajudacusto;
    private $vrproventosapos;
    private $vrlucrdividendo;
    private $vrtitempresa;
    private $vrindenizacao;
    private $vrpecuniario;
    private $vr13salario;
    private $vroutrendtrexcl;
    private $vrqtdemes;
    private $vracumuladorend;
    private $vracumuladodesp;
    private $vracumuladocont;
    private $vracumuladopens;
    private $vracumuladoiret;
    private $vracumuladoisen;
    private $dsinformacompl;
    private $vrimpret13;    
    private $nmpessoa;
    private $nrcpfpessoa;
    private $nrestrutlegal;

    public function __construct($entityManager, $hcmParameters, $nrOrg, $dtCompetencia, $cdInscEstrut){

        parent::__construct(null, $entityManager);

        $this->entityManager  = $entityManager;
        $this->hcmParameters = $hcmParameters;
        
        $this->dirfMagnet = Repositories::FPA_DIRFMAGNET;

        $this->nrorg          = $nrOrg;
        $this->mescompetencia = $dtCompetencia;
        $this->cdinscestrut   = $cdInscEstrut;

        $this->nrCpfAnterior  = -1;
        $this->cdReceita      = -1;
        $this->idPrimeiraExec = true;   
        $this->nrprocesso     = 0;
        $this->dtinclusao     = DateUtil::getDataAtual();
        $this->idativo        = 'S';
    }

    private function deParaMag($Codigo, $IdRec, $Valor, $Valor13){
        switch($Codigo){
            case 'RTRT':
                if($IdRec == '3562'){     
                    $this->vroutrendtrexcl += $Valor;
                }else{                  
                    $this->vrtotalrend     += $Valor;
                }
                $this->vr13salario     += $Valor13; 
                break;
            case 'RTPO':
                $this->vrtotalprev     += $Valor;
                $this->vr13salario     -= $Valor13; 
                break;
            case 'RTDP':
                $this->vr13salario     -= $Valor13; 
                break;
            case 'RTIRF':
                $this->vrtotimpretido  += $Valor;   
                $this->vr13salario     -= $Valor13; 
                $this->vrimpret13      += $Valor13; 
                break;
            case 'RIAP':
                $this->vrpecuniario    += $Valor;   
                break;
            case 'RIO':
                $this->vrpecuniario    += $Valor;   
                break;
            case 'RTPA':    
                $this->vrtotalpensao   += $Valor;
                break;
            case 'RIL96':   
                $this->vroutrendtrexcl += $Valor;   
                break;
            case 'RIIRP':   
                $this->vrindenizacao   += $Valor;   
                break;
        }
    }

    private function deParaCodReceita($CodReceita){
        switch($CodReceita){
            case '0561':
                $this->dsnaturezarend = 'Rendimentos do trabalho assalariado';
                break;
            case '0588':
                $this->dsnaturezarend = 'Trabalho sem Vínculo Empregatício';
                break;
            case '3562':
                $this->dsnaturezarend = 'Participação nos Lucros';
                break;
        }
    }

    public function retornaRegistros(){
        try{
            return $this->entityManager->getRepository(Repositories::FPA_DIRFMAGNET)->retornaRegistrosPorInscricao(
                $this->nrorg, DateUtil::getDataDeString($this->mescompetencia, DateUtil::FORMATO_BRASILEIRO, true), $this->cdinscestrut
            );
        } catch(\Exception $e) {
            throw new \Exception('Não foi possivel localizar registros da DIRF no magnético. O erro foi: '.$e->getMessage());
        }
    }

    public function qdeRegistros(){    
        $cont = 0;
        try{
            $registros = $this->retornaRegistros();
            $cont = count($registros);
        } catch(\Exception $e) {
            throw new \Exception('Não foi possivel localizar registros da DIRF no magnético. O erro foi: '.$e->getMessage());
        }
        return $cont;
    }

    public function addRegCabecal($cdInscEstrut, $idTipoRegistro, $nrPessoaRespons, $idAtivo){
        $this->cdinscestrut    = $cdInscEstrut;
        $this->idtiporegistro  = $idTipoRegistro;
        $this->nrpessoarespons = $nrPessoaRespons;
        $this->idativo         = $idAtivo;
        $this->dtinclusao      = DateUtil::getDataAtual();
        $this->idPrimeiraExec  = true;   
        $this->cdoperinclusao  = $this->hcmParameters->getCdoperador();
        $this->cdoperultatu    = $this->hcmParameters->getCdoperador();
        $this->dtultatu        = DateUtil::getDataAtual();
        $this->nrorginclusao   = $this->nrorg;
        $this->nrorgultatu     = $this->nrorg;
    }
    
    public function addRegVinculo($nrCpf, $nmpessoa, $dtAdmissao, $Codigo, $CodReceita, $Valor, $Valor13, $idrec, $bpfdec, $registro, $complemento, $nrestrutlegal = null){
        if($this->nrCpfAnterior != $nrCpf || $this->cdReceita != $CodReceita){
            $this->nrCpfAnterior = $nrCpf;    
            $this->cdReceita = $CodReceita;
            /* if($this->idPrimeiraExec) {
                $this->idPrimeiraExec = false;  
            } else {                    
                $this->dsinformacompl = $complemento.$this->dsinformacompl;
                $this->setAllToObj();
                $this->persistir();
                $this->zeraRegVinculo();
            } */
            $this->nrvinculom     = null;       
            $this->nrestrutlegal  = $nrestrutlegal;
            $this->nrcpfpessoa    = $nrCpf;
            $this->nmpessoa       = $nmpessoa;
            $this->dtadmissaovinc = $dtAdmissao;
            $this->deParaMag($Codigo, $CodReceita, $Valor, $Valor13);
            $this->idrec = $idrec;
            $this->bpfdec = $bpfdec;
            $this->dslinharegistro .= is_null($this->dslinharegistro) ? $registro : "\n".$registro;
            $this->dsinformacompl  .= $complemento;
            $this->deParaCodReceita($CodReceita);   
        } else {
            $this->deParaMag($Codigo, $CodReceita, $Valor, $Valor13);
            $this->dslinharegistro .= is_null($this->dslinharegistro) ? $registro : "\n".$registro;
        }
    }

    public function fimAddRegVinculo(){
        $this->setAllToObj();
        $this->persistir();     
        $this->zeraRegVinculo();    
    }

    public function excluirCompetencia(){
        $cont = 0;
        try{
            $registros = $this->entityManager->getRepository(Repositories::FPA_DIRFMAGNET)->findBy(array("nrorg"=>$this->nrorg,"mescompetencia"=>(DateUtil::getDataDeString($this->mescompetencia, DateUtil::FORMATO_BRASILEIRO, true))));
            $cont = count($registros);
            /*foreach ($registros as $item){
                $item->delete();
                $cont++;        
            }
            $this->entityManager->flush();*/
            // Retrocesso na tabela de itens de cálculo
            $query = $this->entityManager->getConnection()->prepare("
                DELETE FROM FPA_DIRFMAGNET WHERE NRORG = :NRORG AND MESCOMPETENCIA = :MESCOMPETENCIA");
    
            $query->execute([
                "NRORG"          => $this->nrorg,
                "MESCOMPETENCIA" => $this->mescompetencia]);
            
        } catch(\Exception $e) {
            throw new \Exception('Não foi possivel retroceder a DIRF no magnético. O erro foi: '.$e->getMessage());
        }
        return $cont;
    }

    private function setAllToObj(){ 
        $this->objDirfMagnet = new $this->dirfMagnet;
        $this->nrdirfmagnet = \HCM\Util\NovoCodigo::geraCodigo($this->nrorg,'FPA_DIRFMAGNET'.$this->nrorg, 1, 22, true ); 
        $this->objDirfMagnet->setNrdirfmagnet($this->nrdirfmagnet);
        $this->objDirfMagnet->setNrorg($this->nrorg);
        $this->objDirfMagnet->setMescompetencia(DateUtil::getDataDeString($this->mescompetencia, DateUtil::FORMATO_BRASILEIRO, true));
        $this->objDirfMagnet->setIdtpinscestrutu($this->idtpinscestrutu);
        $this->objDirfMagnet->setCdinscestrut($this->cdinscestrut);
        $this->objDirfMagnet->setDtadmissaovinc($this->dtadmissaovinc);
        $this->objDirfMagnet->setIdtiporegistro($this->idtiporegistro);
        $this->objDirfMagnet->setDslinharegistro($this->idrec."\n".$this->bpfdec."\n".$this->dslinharegistro);
        $this->objDirfMagnet->setNrvinculom($this->nrvinculom);
        $this->objDirfMagnet->setNrpessoarespons($this->nrpessoarespons);
        $this->objDirfMagnet->setIdativo($this->idativo);
        $this->objDirfMagnet->setDtinclusao(DateUtil::getDataAtual());
        $this->objDirfMagnet->setDtultatu(DateUtil::getDataAtual());
        $this->objDirfMagnet->setNrorginclusao($this->nrorg);
        $this->objDirfMagnet->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $this->objDirfMagnet->setNrorgultatu($this->nrorg);
        $this->objDirfMagnet->setCdoperultatu($this->hcmParameters->getCdoperador());
        $this->objDirfMagnet->setNrprocesso($this->nrprocesso);
        $this->objDirfMagnet->setDsnaturezarend($this->dsnaturezarend);
        $this->objDirfMagnet->setVrtotalrend($this->vrtotalrend);
        $this->objDirfMagnet->setVrtotalprev($this->vrtotalprev);
        $this->objDirfMagnet->setVrtotalprevcomp($this->vrtotalprevcomp);
        $this->objDirfMagnet->setVrtotalpensao($this->vrtotalpensao);
        $this->objDirfMagnet->setVrtotimpretido($this->vrtotimpretido);
        $this->objDirfMagnet->setVrparcelaisenta($this->vrparcelaisenta);
        $this->objDirfMagnet->setVrajudacusto($this->vrajudacusto);
        $this->objDirfMagnet->setVrproventosapos($this->vrproventosapos);
        $this->objDirfMagnet->setVrlucrdividendo($this->vrlucrdividendo);
        $this->objDirfMagnet->setVrtitempresa($this->vrtitempresa);
        $this->objDirfMagnet->setVrindenizacao($this->vrindenizacao);
        $this->objDirfMagnet->setVrpecuniario($this->vrpecuniario);
        $this->objDirfMagnet->setVr13salario($this->vr13salario);
        $this->objDirfMagnet->setVroutrendtrexcl($this->vroutrendtrexcl);
        $this->objDirfMagnet->setVrqtdemes($this->vrqtdemes);
        $this->objDirfMagnet->setVracumuladorend($this->vracumuladorend);
        $this->objDirfMagnet->setVracumuladodesp($this->vracumuladodesp);
        $this->objDirfMagnet->setVracumuladocont($this->vracumuladocont);
        $this->objDirfMagnet->setVracumuladopens($this->vracumuladopens);
        $this->objDirfMagnet->setVracumuladoiret($this->vracumuladoiret);
        $this->objDirfMagnet->setVracumuladoisen($this->vracumuladoisen);
        $this->objDirfMagnet->setDsinformacompl($this->dsinformacompl);
        $this->objDirfMagnet->setVrimpret13($this->vrimpret13);
        $this->objDirfMagnet->setNmpessoa($this->nmpessoa);
        $this->objDirfMagnet->setNrcpfpessoa($this->nrcpfpessoa);
        $this->objDirfMagnet->setNrestrutlegal($this->nrestrutlegal);
    }
    
    public function setAllToPSEObj($nrcpfpessoa, $dslinharegistro, $nmpessoa){ 
        $objDirfMagnet = new $this->dirfMagnet;
        $this->nrdirfmagnet = \HCM\Util\NovoCodigo::geraCodigo($this->nrorg,'FPA_DIRFMAGNET'.$this->nrorg, 1, 22, true ); 
        $objDirfMagnet->setNrdirfmagnet($this->nrdirfmagnet);
        $objDirfMagnet->setNrorg($this->nrorg);
        $objDirfMagnet->setMescompetencia(DateUtil::getDataDeString($this->mescompetencia, DateUtil::FORMATO_BRASILEIRO, true));
        $objDirfMagnet->setIdtpinscestrutu($this->idtpinscestrutu);
        $objDirfMagnet->setCdinscestrut($this->cdinscestrut);
        $objDirfMagnet->setIdtiporegistro("PSE");
        $objDirfMagnet->setDslinharegistro($dslinharegistro);
        $objDirfMagnet->setIdativo('S');
        $objDirfMagnet->setNmpessoa($nmpessoa);
        $objDirfMagnet->setNrcpfpessoa($nrcpfpessoa);
        $objDirfMagnet->setNrorginclusao($this->nrorg);
        $objDirfMagnet->setDtinclusao(DateUtil::getDataAtual());
        $objDirfMagnet->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $objDirfMagnet->setNrorgultatu($this->nrorg);
        $objDirfMagnet->setDtultatu(DateUtil::getDataAtual());
        $objDirfMagnet->setCdoperultatu($this->hcmParameters->getCdoperador());
        $objDirfMagnet->setNrprocesso($this->nrprocesso);
        $objDirfMagnet->setDsnaturezarend($this->dsnaturezarend);
        $objDirfMagnet->setDsinformacompl($this->dsinformacompl);
        $this->entityManager->persist($objDirfMagnet);    
        $this->entityManager->flush();
    }

    private function zeraRegCabecal(){
        $this->nrestrutlegal   = null;
        $this->cdinscestrut    = null;
        $this->idtiporegistro  = null;
        $this->nrpessoarespons = null;
        $this->idativo         = null;
    }

    private function zeraRegVinculo(){
        $this->dslinharegistro = null;
        $this->idrec           = null;
        $this->bpfdec          = null;
        $this->nrvinculom      = null;
        $this->dtadmissaovinc  = null;
        $this->vrtotalrend     = null;
        $this->vrtotalprev     = null;
        $this->vrtotalprevcomp = null;
        $this->vrtotalpensao   = null;
        $this->vrtotimpretido  = null;
        $this->vrparcelaisenta = null;
        $this->vrajudacusto    = null;
        $this->vrproventosapos = null;
        $this->vrlucrdividendo = null;
        $this->vrtitempresa    = null;
        $this->vrindenizacao   = null;
        $this->vrpecuniario    = null;
        $this->vr13salario     = null;
        $this->vroutrendtrexcl = null;
        $this->vrqtdemes       = null;
        $this->vracumuladorend = null;
        $this->vracumuladodesp = null;
        $this->vracumuladocont = null;
        $this->vracumuladopens = null;
        $this->vracumuladoiret = null;
        $this->vracumuladoisen = null;
        $this->dsinformacompl  = null;
        $this->vrimpret13      = null;
        $this->nmpessoa        = null;
        $this->nrcpfpessoa     = null;
        $this->objDirfMagnet   = null;
    }
    
    private function persistir(){
        try{
            $this->entityManager->persist($this->objDirfMagnet);
            $this->entityManager->flush();
        } catch(\Exception $e) {
            throw new \Exception('Não foi possivel salvar a DIRF no magnético. O erro foi: '.$e->getMessage());
        }
    }
}