<?php

namespace HCM\SST\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\HCMParameters;

class IndicadoresSaudeTrabalhoController extends Crud {

    protected $parameterBagColumns = array('P_NRORG', 'P_NRORG_PADRAO', 'P_DTMESCOMPETENC', 'P_NRESTRUTLEGAL', 'P_NRESTRUTGEREN', 'P_NRESTRUTSIND', 'P_NRESTRUTTOMAD', 'P_NRTIPOESTRUTGEREN', 'P_NRTIPOESTRUTOMADOR');
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, HCMParameters $hcmParameters){
        $this->parameterBag = $parameterBag;
        $this->hcmParameters = $hcmParameters;
        parent::__construct($dataSourceManager);
    }

    public function getTotalAfastamentosPorCIDLegalOcupacao(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAfastamentosPorCIDLegalOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalAfastamentosPorCIDOcupacao(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAfastamentosPorCIDOcupGeral_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalAfastamentosPorNTEPLegalOcupacao(DTO\Request\Filter $request, DTO\Response $response)
    {   
        
        $this->dataSourceName = "sst_totalAfastamentosPorNTEPLegalOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }
    
    public function getTotalAfastamentosPorNTEPOcupacao(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAfastamentosPorNTEPOcupGeral_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }
    
    protected function processConditionValue($condition)
    {
        return $condition['value'];
    }

    protected function populateParameterBag(FilterCriteria $filterCriteria)
    {

        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );
        return $newFilterCriteria;
    }

    private function adicionaCondicoes($filterData)
    {   
        $filterData->addCondition('P_NRTIPOESTRUTGEREN', '=', $this->hcmParameters->getTipoEstruturaGerencialOrg());
        $filterData->addCondition('P_NRTIPOESTRUTOMADOR', '=', $this->hcmParameters->getTipoEstruturaTomadorOrg());
        return $filterData;
    }
} 