-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 21.x 
--   Created on:     31/10/2023  12:00                        
--   Issue:          [5] 450925 - Cadastro de responsáveis da estrutura
-- ============================================================
-- Table: SST_RESPREGAMB


CREATE TABLE SST_RESPREGAMB
(
    NRORG                 NUMBER          NOT NULL,
    NRREGAMB              NUMBER          NOT NULL,
    NRPARCREGAMB          NUMBER          NOT NULL,
    NRESTRUTURAM          NUMBER          NOT NULL,
    DTINIRESAMB             DATE          NOT NULL,
    DTFIMRESAMB             DATE              NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_SST_RESPREGAMB CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,   
    CONSTRAINT PK_NRREGAMB PRIMARY KEY (NRORG, NRREGAMB),
    CONSTRAINT FK_REGAMBPARC FOREIGN KEY(NRORG,NRPARCREGAMB) REFERENCES PARCNEGOCIO (NRORG,NRPARCNEGOCIO),
    CONSTRAINT FK_REGAMBNRESTRUT FOREIGN KEY (NRORG, NRESTRUTURAM) REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM)
);

