UPDATE GER_VERIFICACAO

SET DSCONSULTAVERIFICA = 'SELECT   
         EC.NMEVENTO EVENTO,
         EM.NMESTRUTURAM EMPRESA,
         DECODE(EC.IDSTATUS, ''P'', ''Pendente de Envio'',
                             ''E'', ''Erro Envio'',
                             ''R'', ''Erro Processamento'') STATUS,         
    TO_CHAR(EC.NRCHAVE) REFERENCIA,
    ec.dsobservacao DESCRICAO
FROM ESO_CADASTRO EC
LEFT JOIN ESTRUTURAM EM
    ON EM.NRORG =:P_NRORG
        AND EM.NRESTRUTURAM = EC.NRESTRUTURAM
LEFT JOIN ESTRUTURAH EH
    ON EH.NRORG = EM.NRORG
        AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
        AND EH.DTMESCOMPETENC = 
    (SELECT MAX(H1.DTMESCOMPETENC)
    FROM ESTRUTURAH H1
    WHERE H1.NRORG = EH.NRORG
            AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
            AND H1.DTMESCOMPETENC <=TRUNC(SYSDATE, ''MM'') )
WHERE EC.NRORG =:P_NRORG
        AND EC.IDSTATUS = ''E''
        AND EC.NRTPAMBIENTE = 1
        AND EC.IDATIVO = ''S''

UNION ALL

SELECT   EP.NMEVENTO EVENTO,
         EM.NMESTRUTURAM EMPRESA,
         DECODE(EP.IDSTATUS, ''P'', ''Pendente de Envio'',
                             ''E'', ''Erro Envio'',
                             ''R'', ''Erro Processamento'') STATUS,         
    PH.NRPESSOA||''-''||PH.NMPESSOA REFERENCIA,
    EP.dsobservacao DESCRICAO
FROM ESO_PERIODICO EP
LEFT JOIN ESTRUTURAM EM
    ON EM.NRORG =:P_NRORG
        AND EM.NRESTRUTURAM = EP.NRESTRUTURAM
LEFT JOIN ESTRUTURAH EH
    ON EH.NRORG = EM.NRORG
        AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
        AND EH.DTMESCOMPETENC = 
    (SELECT MAX(H1.DTMESCOMPETENC)
    FROM ESTRUTURAH H1
    WHERE H1.NRORG = EH.NRORG
            AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
            AND H1.DTMESCOMPETENC <=TRUNC(SYSDATE, ''MM'') )
LEFT JOIN GPE_PESSOAH PH
    ON EP.NRORG = PH.NRORG
        AND PH.NRPESSOA = EP.NRPESSOA
        AND PH.DTMESCOMPETENC = 
    (SELECT MAX(PH1.DTMESCOMPETENC)
    FROM GPE_PESSOAH PH1
    WHERE PH1.NRORG = PH.NRORG
            AND PH1.NRPESSOA = PH.NRPESSOA
            AND PH1.DTMESCOMPETENC <=TRUNC(SYSDATE, ''MM''))
WHERE EP.NRORG =:P_NRORG
        AND EP.IDSTATUS = ''E''
        AND EP.NRTPAMBIENTE = 1
        AND EP.DTMESCOMPETENC =TRUNC(SYSDATE, ''MM'') 
        AND EP.IDATIVO = ''S''

UNION ALL

SELECT   ENP.NMEVENTO EVENTO,
         EM.NMESTRUTURAM EMPRESA,
         DECODE(ENP.IDSTATUS, ''P'', ''Pendente de Envio'',
                             ''E'', ''Erro Envio'',
                             ''R'', ''Erro Processamento'') STATUS,         
    VM.NRVINCULOM||''-''||VM.NMVINCULOM REFERENCIA,
    ENP.dsobservacao DESCRICAO
FROM ESO_NAOPERIODICO ENP
LEFT JOIN ESTRUTURAM EM
    ON EM.NRORG =:P_NRORG
        AND EM.NRESTRUTURAM = ENP.NRESTRUTURAM
LEFT JOIN ESTRUTURAH EH
    ON EH.NRORG = EM.NRORG
        AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
        AND EH.DTMESCOMPETENC = 
    (SELECT MAX(H1.DTMESCOMPETENC)
    FROM ESTRUTURAH H1
    WHERE H1.NRORG = EH.NRORG
            AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
            AND H1.DTMESCOMPETENC <=TRUNC(SYSDATE, ''MM'') )
    LEFT JOIN GPE_VINCULOM     VM ON VM.NRORG = ENP.NRORG
                                 AND VM.NRVINCULOM = ENP.NRVINCULOM
    LEFT JOIN GPE_VINCULOH     VH ON VM.NRVINCULOM = VH.NRVINCULOM
                                 AND VM.NRORG = VH.NRORG
                                 AND VH.DTMESCOMPETENC = (
        SELECT
            MAX(VH1.DTMESCOMPETENC)
        FROM
            GPE_VINCULOH VH1
        WHERE
                VH1.DTMESCOMPETENC <= DECODE(ENP.NMEVENTO, ''S-2190'', ''01/01/3000'', TRUNC(SYSDATE, ''MM''))
            AND VH1.NRORG = VM.NRORG
            AND VH1.NRVINCULOM = VH.NRVINCULOM
    )
WHERE ENP.NRORG =:P_NRORG
        AND ENP.IDSTATUS = ''E''
        AND ENP.NRTPAMBIENTE = 1
        AND ENP.IDATIVO = ''S''
        AND ( ENP.NMEVENTO = ''S-3000''
          OR VH.NRVINCULOM IS NOT NULL )',

DSCONSULTAVERIFICAAUX = 'SELECT   
         EC.NMEVENTO EVENTO,
         EM.NMESTRUTURAM EMPRESA,
         DECODE(EC.IDSTATUS, ''P'', ''Pendente de Envio'',
                             ''E'', ''Erro Envio'',
                             ''R'', ''Erro Processamento'') STATUS,         
    TO_CHAR(EC.NRCHAVE) REFERENCIA,
    ec.dsobservacao DESCRICAO
FROM ESO_CADASTRO EC
LEFT JOIN ESTRUTURAM EM
    ON EM.NRORG =:P_NRORG
        AND EM.NRESTRUTURAM = EC.NRESTRUTURAM
LEFT JOIN ESTRUTURAH EH
    ON EH.NRORG = EM.NRORG
        AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
        AND EH.DTMESCOMPETENC = 
    (SELECT MAX(H1.DTMESCOMPETENC)
    FROM ESTRUTURAH H1
    WHERE H1.NRORG = EH.NRORG
            AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
            AND H1.DTMESCOMPETENC <=TRUNC(SYSDATE, ''MM'') )
WHERE EC.NRORG =:P_NRORG
        AND EC.IDSTATUS = ''E''
        AND EC.NRTPAMBIENTE = 1
        AND EC.IDATIVO = ''S''

UNION ALL

SELECT   EP.NMEVENTO EVENTO,
         EM.NMESTRUTURAM EMPRESA,
         DECODE(EP.IDSTATUS, ''P'', ''Pendente de Envio'',
                             ''E'', ''Erro Envio'',
                             ''R'', ''Erro Processamento'') STATUS,         
    PH.NRPESSOA||''-''||PH.NMPESSOA REFERENCIA,
    EP.dsobservacao DESCRICAO
FROM ESO_PERIODICO EP
LEFT JOIN ESTRUTURAM EM
    ON EM.NRORG =:P_NRORG
        AND EM.NRESTRUTURAM = EP.NRESTRUTURAM
LEFT JOIN ESTRUTURAH EH
    ON EH.NRORG = EM.NRORG
        AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
        AND EH.DTMESCOMPETENC = 
    (SELECT MAX(H1.DTMESCOMPETENC)
    FROM ESTRUTURAH H1
    WHERE H1.NRORG = EH.NRORG
            AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
            AND H1.DTMESCOMPETENC <=TRUNC(SYSDATE, ''MM'') )
LEFT JOIN GPE_PESSOAH PH
    ON EP.NRORG = PH.NRORG
        AND PH.NRPESSOA = EP.NRPESSOA
        AND PH.DTMESCOMPETENC = 
    (SELECT MAX(PH1.DTMESCOMPETENC)
    FROM GPE_PESSOAH PH1
    WHERE PH1.NRORG = PH.NRORG
            AND PH1.NRPESSOA = PH.NRPESSOA
            AND PH1.DTMESCOMPETENC <=TRUNC(SYSDATE, ''MM''))
WHERE EP.NRORG =:P_NRORG
        AND EP.IDSTATUS = ''E''
        AND EP.NRTPAMBIENTE = 1
        AND EP.DTMESCOMPETENC =TRUNC(SYSDATE, ''MM'') 
        AND EP.IDATIVO = ''S''

UNION ALL

SELECT   ENP.NMEVENTO EVENTO,
         EM.NMESTRUTURAM EMPRESA,
         DECODE(ENP.IDSTATUS, ''P'', ''Pendente de Envio'',
                             ''E'', ''Erro Envio'',
                             ''R'', ''Erro Processamento'') STATUS,         
    VM.NRVINCULOM||''-''||VM.NMVINCULOM REFERENCIA,
    ENP.dsobservacao DESCRICAO
FROM ESO_NAOPERIODICO ENP
LEFT JOIN ESTRUTURAM EM
    ON EM.NRORG =:P_NRORG
        AND EM.NRESTRUTURAM = ENP.NRESTRUTURAM
LEFT JOIN ESTRUTURAH EH
    ON EH.NRORG = EM.NRORG
        AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
        AND EH.DTMESCOMPETENC = 
    (SELECT MAX(H1.DTMESCOMPETENC)
    FROM ESTRUTURAH H1
    WHERE H1.NRORG = EH.NRORG
            AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
            AND H1.DTMESCOMPETENC <=TRUNC(SYSDATE, ''MM'') )
    LEFT JOIN GPE_VINCULOM     VM ON VM.NRORG = ENP.NRORG
                                 AND VM.NRVINCULOM = ENP.NRVINCULOM
    LEFT JOIN GPE_VINCULOH     VH ON VM.NRVINCULOM = VH.NRVINCULOM
                                 AND VM.NRORG = VH.NRORG
                                 AND VH.DTMESCOMPETENC = (
        SELECT
            MAX(VH1.DTMESCOMPETENC)
        FROM
            GPE_VINCULOH VH1
        WHERE
                VH1.DTMESCOMPETENC <= DECODE(ENP.NMEVENTO, ''S-2190'', ''01/01/3000'', TRUNC(SYSDATE, ''MM''))
            AND VH1.NRORG = VM.NRORG
            AND VH1.NRVINCULOM = VH.NRVINCULOM
    )
WHERE ENP.NRORG =:P_NRORG
        AND ENP.IDSTATUS = ''E''
        AND ENP.NRTPAMBIENTE = 1
        AND ENP.IDATIVO = ''S''
        AND ( ENP.NMEVENTO = ''S-3000''
          OR VH.NRVINCULOM IS NOT NULL )'
          
WHERE NRVERIFICACAO = 20;