-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     20/03/2024  13:00                        
--   Issue:          472900 - [3][HCM-SST] - Alteração da tela "Alteração da Situação funcional" (não esquecer aba da tela de Vinculo)

-- ============================================================
-- Table:_SST_GRUPOESPECIE
-- ============================================================

CREATE TABLE SST_GRUPOESPECIE
(
    NRORG                 NUMBER          NOT NULL,
    NRGRUPOESPECIE        NUMBER          NOT NULL,
    NMGRUPOESPECIE        VARCHAR2(100)   NOT NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_GRUPOESPECIE CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_SST_NRGRUPOESPECIE PRIMARY KEY (NRGRUPOESPECIE)
);

INSERT INTO SST_GRUPOESPECIE (NRORG, NRGRUPOESPECIE, NMGRUPOESPECIE, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 1, 'Aposentadoria por Idade', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_GRUPOESPECIE (NRORG, NRGRUPOESPECIE, NMGRUPOESPECIE, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 2, 'Aposentadoria por Invalidez', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_GRUPOESPECIE (NRORG, NRGRUPOESPECIE, NMGRUPOESPECIE, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 3, 'Aposentadoria por Tempo de Contribuição', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_GRUPOESPECIE (NRORG, NRGRUPOESPECIE, NMGRUPOESPECIE, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 4, 'Pensão Por Morte', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_GRUPOESPECIE (NRORG, NRGRUPOESPECIE, NMGRUPOESPECIE, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 5, 'Auxílios', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_GRUPOESPECIE (NRORG, NRGRUPOESPECIE, NMGRUPOESPECIE, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 6, 'Benefícios Acidentários', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_GRUPOESPECIE (NRORG, NRGRUPOESPECIE, NMGRUPOESPECIE, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 7, 'Benefícios Assistenciais', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_GRUPOESPECIE (NRORG, NRGRUPOESPECIE, NMGRUPOESPECIE, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 8, 'Espécies Diversas', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_GRUPOESPECIE (NRORG, NRGRUPOESPECIE, NMGRUPOESPECIE, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 9, 'Encargos Previdenciários da União', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;