/******************************************************************************/
/* Database name: TEKNISA_SAAS                                                */
/* Trigger: PTO_ADMISSAO_CONTROLFREQUENCIA                                    */
/* Tabelas: PTO_PROGOCORRENCIA, PTO_ALTEBANCOHORAS                            */
/* Tarefa: 20846 - [HCM-PTO] Processo de Admissão                             */
/*                                                                            */
/* Criação:                                                                   */
/* 22/01/2016 - Leonardo Carvalho                                             */
/*                                                                            */
/******************************************************************************/

create or replace 
TRIGGER PTO_ADMISSAO_CONTROLFREQUENCIA
AFTER INSERT
ON GPE_VINCULOM FOR EACH ROW
DECLARE
  V_NRBANCOHORAS_CLT NUMBER := 1;
  V_NRBANCOHORAS_EST NUMBER := 2;
  V_PRXCODOCOR     VARCHAR2(20);
  
BEGIN
	IF :NEW.NRORG = 20 THEN
      /* Insere as programações de ocorrência necessárias para organização 20 - Grupo Teknisa */
      /* Insere 'Complementa Trabalho para vinculos CLT e Estagiário' */
             
      IF (:NEW.NRTIPOVINCULOM = 1 OR :NEW.NRTIPOVINCULOM = 2) THEN
          NOVO_CODIGO_SC('PTO_PROGOCORRENCIA', V_PRXCODOCOR, 1, :NEW.NRORG);
          INSERT INTO PTO_PROGOCORRENCIA (NRORG,NRPROGOCORRENCIA,NRVINCULOM,DTINICIOPROGOCOR,DTFIMPROGOCOR,IDDIASSEMANA,IDTIPODIACALENDARIO,IDTIPOHORARIO,NRMOTIVOOCORFREQ,NRHORDIAM,NRSITUFREQUENCIA,NRSITUFREQGATILHO,QTMINGATILHOPROGOCOR,QTMAXGATILHOPROGOCOR,VRCOEFICIENTEACRESCIMO,IDPROGOCORRENCIA,QTMINIMAPROGOCOR,QTMAXIMAPROGOCOR,DSOBSERVACAO,IDATIVO,NRORGINCLUSAO,DTINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,DTULTATU,CDOPERULTATU,NRTIPOPROGOCORRENCIA,NRMARCACAOPONTO,NRINTERVALOHORARIO,IDPROGOCORCONFIRMADA,CDOPERVERIFICADO,DSOBSERVACAORECUSA) 
               VALUES (:NEW.NRORG, TO_NUMBER(V_PRXCODOCOR), :NEW.NRVINCULOM, :NEW.DTADMISSAOVINC, NULL, '1111111', NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'S', :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, '21' ,NULL, NULL, 'S', NULL, NULL);
               
      END IF; 
      
      /* Insere 'Autorizar Hora Extra' para vinculos CLT */
      /*IF (:NEW.NRTIPOVINCULOM = 1) THEN          
          /* Uma com Tipo de Horário Normal * / 
          NOVO_CODIGO_SC('PTO_PROGOCORRENCIA', V_PRXCODOCOR, 1, :NEW.NRORG);
          INSERT INTO PTO_PROGOCORRENCIA (NRORG,NRPROGOCORRENCIA,NRVINCULOM,DTINICIOPROGOCOR,DTFIMPROGOCOR,IDDIASSEMANA,IDTIPODIACALENDARIO,IDTIPOHORARIO,NRMOTIVOOCORFREQ,NRHORDIAM,NRSITUFREQUENCIA,NRSITUFREQGATILHO,QTMINGATILHOPROGOCOR,QTMAXGATILHOPROGOCOR,VRCOEFICIENTEACRESCIMO,IDPROGOCORRENCIA,QTMINIMAPROGOCOR,QTMAXIMAPROGOCOR,DSOBSERVACAO,IDATIVO,NRORGINCLUSAO,DTINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,DTULTATU,CDOPERULTATU,NRTIPOPROGOCORRENCIA,NRMARCACAOPONTO,NRINTERVALOHORARIO,IDPROGOCORCONFIRMADA,CDOPERVERIFICADO,DSOBSERVACAORECUSA) 
               VALUES (:NEW.NRORG, TO_NUMBER(V_PRXCODOCOR), :NEW.NRVINCULOM, :NEW.DTADMISSAOVINC, NULL, '1111111', NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'S', :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, '1' ,NULL, NULL, 'S', NULL, NULL);    
          
          /* Uma com Tipo de Horário Folga * / 
          NOVO_CODIGO_SC('PTO_PROGOCORRENCIA', V_PRXCODOCOR, 1, :NEW.NRORG);
          INSERT INTO PTO_PROGOCORRENCIA (NRORG,NRPROGOCORRENCIA,NRVINCULOM,DTINICIOPROGOCOR,DTFIMPROGOCOR,IDDIASSEMANA,IDTIPODIACALENDARIO,IDTIPOHORARIO,NRMOTIVOOCORFREQ,NRHORDIAM,NRSITUFREQUENCIA,NRSITUFREQGATILHO,QTMINGATILHOPROGOCOR,QTMAXGATILHOPROGOCOR,VRCOEFICIENTEACRESCIMO,IDPROGOCORRENCIA,QTMINIMAPROGOCOR,QTMAXIMAPROGOCOR,DSOBSERVACAO,IDATIVO,NRORGINCLUSAO,DTINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,DTULTATU,CDOPERULTATU,NRTIPOPROGOCORRENCIA,NRMARCACAOPONTO,NRINTERVALOHORARIO,IDPROGOCORCONFIRMADA,CDOPERVERIFICADO,DSOBSERVACAORECUSA) 
               VALUES (:NEW.NRORG, TO_NUMBER(V_PRXCODOCOR), :NEW.NRVINCULOM, :NEW.DTADMISSAOVINC, NULL, '1111111', NULL, 'F', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'S', :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, '1' ,NULL, NULL, 'S', NULL, NULL);    
      END IF;*/
      
      /* Insere 'Abonar Saída Intrajornada' de 00:10 para vinculos Estagiários */
      IF (:NEW.NRTIPOVINCULOM = 2) THEN
          NOVO_CODIGO_SC('PTO_PROGOCORRENCIA', V_PRXCODOCOR, 1, :NEW.NRORG);
          INSERT INTO PTO_PROGOCORRENCIA (NRORG,NRPROGOCORRENCIA,NRVINCULOM,DTINICIOPROGOCOR,DTFIMPROGOCOR,IDDIASSEMANA,IDTIPODIACALENDARIO,IDTIPOHORARIO,NRMOTIVOOCORFREQ,NRHORDIAM,NRSITUFREQUENCIA,NRSITUFREQGATILHO,QTMINGATILHOPROGOCOR,QTMAXGATILHOPROGOCOR,VRCOEFICIENTEACRESCIMO,IDPROGOCORRENCIA,QTMINIMAPROGOCOR,QTMAXIMAPROGOCOR,DSOBSERVACAO,IDATIVO,NRORGINCLUSAO,DTINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,DTULTATU,CDOPERULTATU,NRTIPOPROGOCORRENCIA,NRMARCACAOPONTO,NRINTERVALOHORARIO,IDPROGOCORCONFIRMADA,CDOPERVERIFICADO,DSOBSERVACAORECUSA) 
               VALUES (:NEW.NRORG, TO_NUMBER(V_PRXCODOCOR), :NEW.NRVINCULOM, :NEW.DTADMISSAOVINC, NULL, '1111111', NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '10', NULL, 'S', :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, '23' ,NULL, NULL, 'S', NULL, NULL);    
      END IF;
      
      /* Insere 'Alteração de Banco de Horas' para o vinculo admitido, diferente entre tipo de vínculo */
      IF (:NEW.NRTIPOVINCULOM = 1) THEN
          NOVO_CODIGO_SC('PTO_ALTEBANCOHORAS', V_PRXCODOCOR, 1, :NEW.NRORG);
          INSERT INTO PTO_ALTEBANCOHORAS (NRORG,NRALTEBANCOHORAS,NRBANCOHORAS,NRVINCULOM,DTINICIOALTEBHORAS,DTFIMALTEBHORAS,IDATIVO,NRORGINCLUSAO,DTINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,DTULTATU,CDOPERULTATU) 
           VALUES (:NEW.NRORG, TO_NUMBER(V_PRXCODOCOR), V_NRBANCOHORAS_CLT, :NEW.NRVINCULOM, TRUNC(:NEW.DTADMISSAOVINC, 'MONTH'), NULL, 'S', :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO);
          
      ELSIF (:NEW.NRTIPOVINCULOM = 2) THEN
          NOVO_CODIGO_SC('PTO_ALTEBANCOHORAS', V_PRXCODOCOR, 1, :NEW.NRORG);
          INSERT INTO PTO_ALTEBANCOHORAS (NRORG,NRALTEBANCOHORAS,NRBANCOHORAS,NRVINCULOM,DTINICIOALTEBHORAS,DTFIMALTEBHORAS,IDATIVO,NRORGINCLUSAO,DTINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,DTULTATU,CDOPERULTATU) 
           VALUES (:NEW.NRORG, TO_NUMBER(V_PRXCODOCOR), V_NRBANCOHORAS_EST, :NEW.NRVINCULOM, TRUNC(:NEW.DTADMISSAOVINC, 'MONTH'), NULL, 'S', :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO);
      END IF;
    
	END IF;
	
END;
/

/*******************************************************************************************/
/* Database name: TEKNISA_SAAS                                                             */
/* Trigger: PTO_GERA_OCORRENCIA_FERIAS                                                     */
/* Tabelas: FPA_FERIAS, FPA_GOZOFERIAS, PTO_PROGOCORRENCIA                                 */
/* Tarefa: 33416 - [PTO-APP] Criar trigger ao lançar férias gerar ocorrência de frequência */
/*                                                                                         */
/* Criação:                                                                                */
/* 13/07/2016 - Leonardo Carvalho                                                          */
/*                                                                                         */
/*******************************************************************************************/

CREATE OR REPLACE 
TRIGGER PTO_GERA_OCORRENCIA_FERIAS
AFTER INSERT OR UPDATE OR DELETE
ON FPA_GOZOFERIAS FOR EACH ROW
DECLARE  
  V_NRMOTIVOOCORFREQ_FERIAS NUMBER := 22;
  V_NRSITUFREQUENCIA_FERIAS NUMBER := 21000;
  V_NRTIPOOCOR_ABONOFALTA NUMBER := 5;
  V_NRVINCULOM NUMBER;
  V_NRORG NUMBER;
  V_NRFERIAS NUMBER;
  V_PRXCODOCOR VARCHAR2(20);
  
BEGIN
	/* Insere as programação de ocorrência para abonar falta no período de férias do vínculo */
  
	  IF (INSERTING OR UPDATING) THEN
		 V_NRORG    := :NEW.NRORG;
		 V_NRFERIAS := :NEW.NRFERIAS;
	  ELSIF DELETING THEN
		 V_NRORG    := :OLD.NRORG;
		 V_NRFERIAS := :OLD.NRFERIAS;
	  END IF;
        
      /* Busca o número do vínculo do gozo de férias */
      SELECT NRVINCULOM
        INTO V_NRVINCULOM
        FROM FPA_FERIAS    
       WHERE NRORG    = V_NRORG
         AND NRFERIAS = V_NRFERIAS;
       
      IF INSERTING THEN
       
        /* Insere programação de ocorrência no período do gozo de férias */   
        NOVO_CODIGO_SC('PTO_PROGOCORRENCIA', V_PRXCODOCOR, 1, :NEW.NRORG);
        INSERT INTO PTO_PROGOCORRENCIA (NRORG,NRPROGOCORRENCIA,NRVINCULOM,DTINICIOPROGOCOR,DTFIMPROGOCOR,IDDIASSEMANA,IDTIPODIACALENDARIO,IDTIPOHORARIO,NRMOTIVOOCORFREQ,NRHORDIAM,NRSITUFREQUENCIA,NRSITUFREQGATILHO,QTMINGATILHOPROGOCOR,QTMAXGATILHOPROGOCOR,VRCOEFICIENTEACRESCIMO,IDPROGOCORRENCIA,QTMINIMAPROGOCOR,QTMAXIMAPROGOCOR,DSOBSERVACAO,IDATIVO,NRORGINCLUSAO,DTINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,DTULTATU,CDOPERULTATU,NRTIPOPROGOCORRENCIA,NRMARCACAOPONTO,NRINTERVALOHORARIO,IDPROGOCORCONFIRMADA,CDOPERVERIFICADO,DSOBSERVACAORECUSA) 
             VALUES (:NEW.NRORG, TO_NUMBER(V_PRXCODOCOR), V_NRVINCULOM, :NEW.DTINIGOZOFERIAS, :NEW.DTFIMGOZOFERIAS, '1111111', NULL, 'N', V_NRMOTIVOOCORFREQ_FERIAS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'S', :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, :NEW.NRORG, SYSDATE, :NEW.CDOPERINCLUSAO, V_NRTIPOOCOR_ABONOFALTA, NULL, NULL, 'S', NULL, NULL);
      
      ELSIF UPDATING THEN
      
        /* Atualiza dados da programação de ocorrência no período do gozo de férias */
        UPDATE PTO_PROGOCORRENCIA SET DTINICIOPROGOCOR = :NEW.DTINIGOZOFERIAS, DTFIMPROGOCOR = :NEW.DTFIMGOZOFERIAS
         WHERE NRORG                = :OLD.NRORG
           AND NRVINCULOM           = V_NRVINCULOM
           AND DTINICIOPROGOCOR     = :OLD.DTINIGOZOFERIAS
           AND DTFIMPROGOCOR        = :OLD.DTFIMGOZOFERIAS
           AND NRMOTIVOOCORFREQ     = V_NRMOTIVOOCORFREQ_FERIAS
           AND NRTIPOPROGOCORRENCIA = V_NRTIPOOCOR_ABONOFALTA;
      
      ELSIF DELETING THEN
      
        /* Exclui programação de ocorrência no período do gozo de férias */
        DELETE FROM PTO_PROGOCORRENCIA
         WHERE NRORG                = V_NRORG
           AND NRVINCULOM           = V_NRVINCULOM
           AND DTINICIOPROGOCOR     = :OLD.DTINIGOZOFERIAS
           AND DTFIMPROGOCOR        = :OLD.DTFIMGOZOFERIAS
           AND NRMOTIVOOCORFREQ     = V_NRMOTIVOOCORFREQ_FERIAS
           AND NRTIPOPROGOCORRENCIA = V_NRTIPOOCOR_ABONOFALTA;
      
      END IF;        
END;
/